# LSE DS105W (2023/24) - Weeks 09, 10 & 11

<figure>
    <img src="./figures/DS105L_favicon.png" alt="Image Created with Stable Diffusion"  role="presentation" style="object-fit: cover;width:5em;height:5em;border-radius: 50%;">
    <figcaption>
        <span style="display:inline-block;font-size:0.3em;width:30%;">
        </span>
    </figcaption>

</figure>
<br/>
<br/>

This repository contains code and data used in Weeks 09, 10, and 11 of 2023's edition of [DS105W](https://lse-dsi.github.io/DS105/2023/winter-term/).

# 🗂️ FOLDER STRUCTURE

```plaintext
.
├── README.md
├── credentials.json (**you must create this file**)
├── data
├── figures
├── notebooks
│   └── NB01-Data-Collection.ipynb (adapted from W08 lecture)
│   └── NB02-Database.ipynb (created in W09 lecture)
│   └── NB03-Exploratory-Data-Analysis.ipynb (created in W09 & W10 lecture)
│   └── NB04-Text-Analysis.ipynb (created in W11 lecture)
├── src
│   └── reddit.py
└── requirements.txt

```


# 📚 PREPARATION

If you want to replicate the analysis in this notebook, you will need to:

1. Clone this repository to your computer
2. Add it to your VS Code workspace
3. Create a [Reddit account](https://www.reddit.com/register/)
4. Then, follow these [First Steps](https://github.com/reddit-archive/reddit/wiki/OAuth2-Quick-Start-Example#first-steps) to create an app and get your credentials.
5. Take note of your Reddit username and password, as well as the client ID and client secret of the app you created:

    ![](./figures/screenshot_reddit_app_details.png)

6. Create a plain text file called `credentials.json` and add your Reddit credentials there:

    ```json
    {
        "reddit_username": "<your Reddit username>",
        "reddit_password": "<your Reddit password>",
        "app_client_id": "<your Reddit app's client ID>",
        "app_client_secret": "<your Reddit app's client secret>"
    }
    ```

7. Set up your conda environment:

    ```bash
    conda create -n venv-ds105 python=3.11 ipython
    conda activate venv-ds105
    ```
8. Make sure `pip` is installed inside that environment:

    ```bash
    conda install pip
    ```

9. Now use that pip to install the packages:

    ```bash
    python -m pip install -r requirements.txt
    ```


**🖇️ USEFUL LINKS:**

- W3 Schools' [HTTP Request Methods](https://www.w3schools.com/tags/ref_httpmethods.asp) page
- Reddit API's [documentation](https://www.reddit.com/dev/api)
- The [JSON Crack Extension](https://marketplace.visualstudio.com/items?itemName=AykutSarac.jsoncrack-vscode) for VS Code or [the website version](https://jsoncrack.com/)
- 🐼 pandas' [`pd.json_normalize()` function documentation](https://pandas.pydata.org/pandas-docs/stable/reference/api/pandas.json_normalize.html)